
// Program bdcy fragmentem rozwizania zadania T4 I stopnia Olimpiady Fizycznej 2016/2017
// Autor: Jacek Jasiak listopad 2016
// Program zapisuje najkrtszy czas oraz czas dla danego a *.txt 

   // Metoda A
#include <stdio.h>
#include <cmath>


FILE *f1, *fn;
    double x, y, v ; // prdko i wsprzedne pooenia
    double t, dt ; //czas, krok czasowy 
    double c ; // = beta/m -- parametr z treci zadania: 0, 0.0001, 0.001, 0.01
    double a ; //parametr a z rwnania paraboli y = a x^2 + b x + c = x*( a(x-x1) +y1/x1)
    double x1  ; // wsprzdna x kocowego pooenia
    double yk ;  // wsprzdna y kocowego pooenia
    double g ; // przyspieszenie grawitacyjne
    double tnaj, ptnaj; // najkrotszy czas, poprzedni najkrotszy, azakres
    double anajmin, panajmin, anajmax, panajmax ; //zakres a odpowiadajacy pnaj oraz ptanaj
    double da; // krok a
    double y50min, y50max; // wartoci y(x) dla x=50;
    
 double yodx( double x ) // y od x
 {
   return x*( a*(x-x1) + yk/x1 )	;
 
  }  
 double yp( double x ) // dy/dx
 {
   return  a* (2*x-x1) +yk/x1 ;
 
  }  
  
  double dsdx( double x ) // ds/dx
 {
    double yp_ = yp(x);
    return sqrt( 1.0d + yp_*yp_ );
  } 

  double dsdy( double x ) // ds/dy 
 {
    double iyp_ = 1.0d/yp(x);
    return dsdx(x)/yp(x);
  } 
    
    
 int krok() // pojedyncza iteracja  (krok)
{     
      double f ;
      x = x + v/dsdx(x)*dt/2; 
	  f = -g/dsdy(x) - c * v*v ; // sia wzdu toru

      v = v + f*dt; // prdko w nastpnej chwili 
      x = x + v/dsdx(x)*dt/2; // poozenie w nastpnej chwili
      t = t + dt ;
      y = yodx(x); 
     return 0;
}

 int ruch() // ruch dla zadanych wartoci parametrw, zapisuje do pliku plik
{
	x=0; y=0; //pooenie pocztkowe
	v=0;  // prdko pocztkowa
	t = 0; // czas poczatkowy
	int i; // numeracja kroku, uzywana tylko do spradzania poprawnosci dzialania kodu
	i=0;
	while (x<x1 and (v>0 or i==0 ) and i<=1000000000) {
	      krok();
	      i++  ;   
		   }
	      if (x>=x1) {
	      	  fprintf(f1, "%.9f          %.9f          %.9f           %.9f          %.9f          %.9f          \n",a,t, tnaj, v, c, dt); // zapisuje czas
			  if (t<=tnaj) {
			   if (t==tnaj){
			  	if (anajmin>a){ anajmin = a; y50min = yodx(50);}
			  	if (anajmax<a){ anajmax = a; y50max = yodx(50);}
			  }
			  if (t<tnaj){
			  ptnaj = tnaj; panajmin = anajmin; panajmax = anajmax; tnaj = t; anajmin = a; anajmax = a;
			  y50min = yodx(50); y50max = yodx(50); } 
            }
		  }	     

	printf("koniec ptli\n");
	return 0;
}
int najkrotszyCzas(double amin, double amax, double da){
 tnaj = 999999; anajmin = -100;	anajmax = 100;
 a = amin;
 while (a <= amax) {
  printf("pocztek ptli c= %.9f a=%.9f amin =%.9f  amax=%.9f  da=%.9f\n", c, a, amin, amax, da);
  ruch();
   a = a + da;
  } 

  if (tnaj < 999999 ) {
    fprintf(fn, "%.9f          %.9f            %.9f          %.9f             %.9f             %.9f             %.9f             %.9f             %.9f             %.9f          \n",
	c, tnaj, anajmin, anajmax, ptnaj, panajmin, panajmax, dt, y50min, y50max); // zapisuje czas minimalny
 
  }
}

int main()
{
// mniejsza liczba krokw  
 x1 = 100 ; // wsprzdna x kocowego pooenia
 yk = -1.0;  // wsprzdna y kocowego pooenia
 g = 10; // przyspieszenie grawitacyjne
 const char* pliknaj = ".\\T4_2016Anaj.txt"; // plik z wartociami minimalnymi;
 const char* plika = ".\\T4_2016A.txt"; // plik z wartociami minimalnymi;
 fn=fopen(pliknaj,"w");
 fprintf(fn, "c                    tnaj                   anajmin              anajmax                 ptnaj                   panajmin                panajmax                   dt                   y50min                   y50max\n"); // nagwki kolumna dla czasu minimalnego

 f1=fopen( plika,"w");
 fprintf(f1, "a                    t                   tnaj                  v                  c                   dt\n"); //nagwki kolumn dla czasu przy zadanym a
  
  dt = 0.1; da = 0.05d/100 ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f      \n",dt, da*x1 );
  c=0; najkrotszyCzas(0, 5.0d/100, da );// najkrotszyCzas(double amin, double amax, double da)
  c=0.0001; najkrotszyCzas(0, 5.0d/100, da );
  c=0.001; najkrotszyCzas(0, 5.0d/100, da );
  c=0.01; najkrotszyCzas(0, 5.0d/100, da );
  
  dt = 0.05; da = 0.05d/100 ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f     \n",dt, da*x1 );
  c=0; najkrotszyCzas(0, 5.0d/100, da );// najkrotszyCzas(double amin, double amax, double da)
  c=0.0001; najkrotszyCzas(0, 5.0d/100, da );
  c=0.001; najkrotszyCzas(0, 5.0d/100, da );
  c=0.01; najkrotszyCzas(0, 5.0d/100, da );
  
  dt = 0.02; da = 0.05d/100 ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f       \n",dt, da*x1 );
  c=0; najkrotszyCzas(0, 5.0d/100, da );// najkrotszyCzas(double amin, double amax, double da)
  c=0.0001; najkrotszyCzas(0, 5.0d/100, da );
  c=0.001; najkrotszyCzas(0, 5.0d/100, da );
  c=0.01; najkrotszyCzas(0, 5.0d/100, da );
  
  dt = 0.02; da = 0.001d/100 ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f      \n",dt, da*x1 );
  c=0.001; najkrotszyCzas(0.1d/100, 2.0d/100, da );
  dt = 0.02; da = 0.0005d/100 ; fprintf(fn, "   dt = %.9f    da = %.9f      \n",dt, da*x1 );
  c=0.01; najkrotszyCzas(0, 0.5d/100, da );
  
  dt = 0.01; da = 0.001d/100 ; fprintf(fn, "   dt = %.9f    da*x1 = %.9f    \n",dt, da*x1 );
  c=0.001; najkrotszyCzas(0.1d/100, 2.0d/100, da );
  dt = 0.01; da = 0.0005d/100 ; fprintf(fn, "   dt = %.9f    da*x1 = %.9f    \n",dt, da*x1 );
  c=0.01; najkrotszyCzas(0, 0.5d/100, da );
  
  fprintf(fn, "\n   Przypadki a=0 / ruch po prostej - tylko parametry c, t0 maja tu znaczenie \n" );
  fprintf(fn, "c                    tnaj                   \n"); 
  dt = 0.1; fprintf(fn, "\n   dt =   %.9f   \n",dt );
  c=0.00; najkrotszyCzas(0, 0, 1 );  
  c=0.0001; najkrotszyCzas(0, 0, 1 );
  c=0.001; najkrotszyCzas(0, 0, 1 );  
  c=0.01; najkrotszyCzas(0, 0, 1 );

  dt = 0.05; fprintf(fn, "\n   dt =   %.9f   \n",dt );
  c=0.00; najkrotszyCzas(0, 0, 1 );  
  c=0.0001; najkrotszyCzas(0, 0, 1 );
  c=0.001; najkrotszyCzas(0, 0, 1 );  
  c=0.01; najkrotszyCzas(0, 0, 1 );
  
  dt = 0.02; fprintf(fn, "\n   dt =   %.9f   \n",dt );
  c=0.00; najkrotszyCzas(0, 0, 1 );  
  c=0.0001; najkrotszyCzas(0, 0, 1 );
  c=0.001; najkrotszyCzas(0, 0, 1 );  
  c=0.01; najkrotszyCzas(0, 0, 1 );    
  
  /* //ten fragment jest szczegolowym badaniem dla c = 0.001
  fprintf(fn, "  szczegolowo przypadek c =0.001   \n",dt, da );
  dt = 0.02; dax1 = 0.001d ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f      \n",dt, dax1 );
  c=0.001; najkrotszyCzas(0.1d/x1, 2.0d/x1, dax1/x1 );
  dt = 0.01; dax1 = 0.001d ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f      \n",dt, dax1 );
  c=0.001; najkrotszyCzas(0.1d/x1, 2.0d/x1, dax1/x1 );
  dt = 0.005; dax1 = 0.001d ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f      \n",dt, dax1 );
  c=0.001; najkrotszyCzas(0.1d/x1, 2.0d/x1, dax1/x1 );
  dt = 0.005; dax1 = 0.0005 ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f      \n",dt, dax1 );
  c=0.001; najkrotszyCzas(0.1d/x1, 2.0d/x1, dax1/x1 );
  dt = 0.002; dax1 = 0.0005d ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f      \n",dt, dax1 );
  c=0.001; najkrotszyCzas(0.1d/x1, 2.0d/x1, dax1/x1 );
  dt = 0.001; dax1 = 0.0001d ; fprintf(fn, "\n   dt = %.9f    da*x1 = %.9f      \n",dt, dax1 );
  c=0.001; najkrotszyCzas(0.1d/x1, 0.4d/x1, dax1/x1 );
  */
   fclose(f1); 
   fclose(fn); // zamyka plik
   return 0;
}

