// Program bdcy fragmentem rozwizania zadania T4 I stopnia Olimpiady Fizycznej 2016/2017
// Autor: Jacek Jasiak listopad 2016
// Program zapisuje najkrtszy czas oraz czas dla danego a *.txt 
       // Metoda B
#include <stdio.h>
#include <cmath>


FILE *f1, *fn;
    double x, y, v ; // prdko i wsprzedne pooenia
    double vp ; //poprzednia prdko
    double t, dt ; //czas, krok czasowy 
    double c ; // = beta/m -- parametr z treci zadania: 0, 0.0001, 0.001, 0.01
    double a ; //parametr a z rwnania paraboli y = a x^2 + b x + c = x*( a(x-x1) +yk/x1)
    double x1  ; // wsprzdna x kocowego pooenia
    double yk ;  // wsprzdna y kocowego pooenia
    double g ; // przyspieszenie grawitacyjne
    double E; // energia kinetyczna podzielona przez mase
    double dx; // szerokosc pojedynczego przeczialu (krok we spolrzednej x) 
	int n; // liczba przedzialow
    double tnaj, ptnaj; // najkrotszy czas, poprzedni najkrotszy, azakres
    double anajmin, panajmin, anajmax, panajmax ; //zakres a odpowiadajacy pnaj oraz ptanaj
    
 double yodx( double x ) // y od x
 {
   return x*( a*(x-x1) + yk/x1 )	;
 
  }  
 double yp( double x ) // dy/dx
 {
   return  a* (2*x-x1) +yk/x1 ;
 
  }  
  
  double dsdx( double x ) // ds/dx
 {
    double yp_ = yp(x);
    return sqrt( 1.0d + yp_*yp_ );
  } 

  double dsdy( double x ) // ds/dy 
 {
    return dsdx(x)/yp(x);
  } 
    
    
 int krok() // pojedyncza iteracja  (krok)
{     

      E = E + (-g*yp(x) - c * v*v*dsdx(x))*dx; 
	  if (E>=0) { 
	  v = sqrt(2*E)  ; 
	  t = t + 2*dsdx(x)*dx/(vp+v);
	  x = x + dx;
	  vp = v;
	  } 
     return 0;
}

 int ruch() // ruch da zadanych wartoci parametrw, zapisuje do pliku plik
{
	x=0; y=0; //pooenie pocztkowe
	v=0;  vp = 0;// prdko pocztkowa
	t = 0; E = 0;
	int i; // numeracja kroku, uzywana tylko do spradzania poprawnosci dzialania kodu
	i=0;
	dx = x1/n; 
	x = 0 + dx/2; //  x bierzemy w poowie danego przedziau, co zwieksza dokadno
	while (x<x1 and E >= 0 and i<=1000000000) {
	      krok();
	       i++  ;   
		   }
	      if (E >=0 ) {
	      	  fprintf(f1, "%.9f          %.9f          %.9f           %.9f          %.9f          %.9f          \n",a,t, tnaj, v, c, E); // zapisuje czas
			  if (t<=tnaj) {
			   if (t==tnaj){
			  	if (anajmin>a){ anajmin = a;}
			  	if (anajmax<a){ anajmax = a;}
			  }
			  if (t<tnaj){
			  ptnaj = tnaj; panajmin = anajmin; panajmax = anajmax; tnaj = t; anajmin = a; anajmax = a; } 
            }
		  }	     

	printf("koniec ptli\n");
	return 0;
}
int najkrotszyCzas(double amin, double amax, double da){
 tnaj = 999999; anajmin = -100;	anajmax = 100;
 a = amin;
 while (a <= amax) {
  printf("pocztek ptli c= %.9f a=%.9f amin =%.9f  amax=%.9f  da=%.9f\n", c, a, amin, amax, da);
  ruch();
   a = a + da;
  } 

  if (tnaj < 999999 ) {
    fprintf(fn, "%.9f          %.9f            %.9f          %.9f             %.9f             %.9f             %.9f             %.9f          \n",
	c, tnaj, anajmin, anajmax, ptnaj, panajmin, panajmax, da); // zapisuje czas minimalny
 
  }
}

int main()
{
// mniejsza liczba krokw  
 x1 = 100 ; // wsprzdna x kocowego pooenia
 yk = -1.0;  // wsprzdna y kocowego pooenia
 g = 10; // przyspieszenie grawitacyjne
 const char* pliknaj = ".\\T4_2016bnaj.txt"; // plik z wartociami minimalnymi;
 const char* plika = ".\\T4_2016b.txt"; // plik z czasem spadku ;
 fn=fopen(pliknaj,"w");
 fprintf(fn, "c                    tnaj                   anajmin              anajmax                 ptnaj                   panajmin                panajmax                   da\n"); // nagwki kolumna dla czasu minimalnego

 f1=fopen( plika,"w");
 fprintf(f1, "a                    t                   tnaj                  v                     c                   E\n"); //nagwki kolumn dla czasu przy zadanym a
    n = 100; fprintf(fn, "   n =   %i   da*x1 = %.9f \n",n, 0.05d  );
  c=0; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );// najkrotszyCzas(double amin, double amax, double da)
  c=0.0001; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
  c=0.001; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
  c=0.01; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
    n = 200; fprintf(fn, "   n =   %i \n",n );
  c=0; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );// najkrotszyCzas(double amin, double amax, double da)
  c=0.0001; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
  c=0.001; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
  c=0.01; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
    n = 400; fprintf(fn, "   n =   %i \n",n );
  c=0; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );// najkrotszyCzas(double amin, double amax, double da)
  c=0.0001; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
  c=0.001; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
  c=0.01; najkrotszyCzas(0, 5.0d/100, 0.05d/100 );
  
    n = 200; fprintf(fn, "\n   n =   %i   da*x1 = 0.001 lub 0.0005 \n",n  );
  c=0.001; najkrotszyCzas(0.1d/100, 0.4d/100, 0.001d/100 );
  c=0.01; najkrotszyCzas(0, 0.2d/100, 0.0005d/100 );
     n = 400; fprintf(fn, "\n   n =   %i   da*x1 = 0.001 lub 0.0005 \n",n  );
  c=0.001; najkrotszyCzas(0.1d/100, 0.4d/100, 0.001d/100 );
  c=0.01; najkrotszyCzas(0, 0.2d/100, 0.0005d/100 );

  fprintf(fn, "\n Jeszcze raz w szczegolnych przypadkach \n" );

  fprintf(fn, "\n   Przypadki a=0 / ruch po prostej - tylko parametry c, t0 maja tu znaczenie \n" );
fprintf(fn, "c                    t0                   \n"); 
 // wykorzystujemy tu funkcje najkrotszyCzas do znalezienia czasu spadku dla a=0 sta niektore parametry nie maja znaczenia 
  n = 200; fprintf(fn, "\n   n =   %i   \n",n );
  c=0.00; najkrotszyCzas(0, 0, 1 );
  n = 400; fprintf(fn, "   n =   %i   \n",n );
  c=0.00; najkrotszyCzas(0, 0, 1 );
  n = 200; fprintf(fn, "\n   n =   %i   \n",n );
  c=0.0001; najkrotszyCzas(0, 0, 1 );
  n = 400; fprintf(fn, "   n =   %i   \n",n );
  c=0.0001; najkrotszyCzas(0, 0, 1 );
  n = 200; fprintf(fn, "\n   n =   %i   \n",n );
  c=0.001; najkrotszyCzas(0, 0, 1 );
  n = 400; fprintf(fn, "   n =   %i   \n",n );
  c=0.001; najkrotszyCzas(0, 0, 1 );
  n = 200; fprintf(fn, "\n   n =   %i   \n",n );
  c=0.01; najkrotszyCzas(0, 0, 1 );
  n = 400; fprintf(fn, "   n =   %i   \n",n );
  c=0.01; najkrotszyCzas(0, 0, 1 );
  


   fclose(f1); 
   fclose(fn); // zamyka plik
   return 0;
}

